#!/usr/bin/perl

use strict;
use warnings;

BEGIN {
    if ($0 =~ m|^(.*)/[^/]+$|) {
        push(@INC, $1);
    }
}

use SOAP::Lite +trace => 'debug';
use MIME::Base64;
use HPSMSOAP;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my %argument = ();
foreach my $a (@ARGV) {
    if ($a =~ s/^([^=]+)=//) {
        $argument{$1} = $a;
    } else {
        die "invalid argument [$a]\n";
    }
}

my @xargs = ();
foreach my $k (keys %argument) {
    push(@xargs, SOAP::Data->name($k => $argument{$k}));
}
my $x = SOAP::Data->value(@xargs);

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/ChangeManagement.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");
$soap->on_action(sub { '"Update"'; } );

my $keys = SOAP::Data->name('keys' => '')->type('');
my $instance = SOAP::Data->name('instance' => \$x)->type('');
my $model = SOAP::Data->name('model' => \SOAP::Data->value($keys, $instance));
my $som = $soap->call('UpdateChange', $model);

soapfault($som);
soapstatus($som);
soapdata($som, '//UpdateChangeResponse/messages', 1);
soapdata($som, '//UpdateChangeResponse/model', 0);
